package org.jboss.qa.brms.performance.domain;

/**
 * Common super class for all events used in Fusion tests.
 */
public abstract class Event {
    protected int id;
    /** Duration of event in ms */
    protected long duration;
    /** Description of event */
    protected String description;

    public Event() {
        duration = 0;
    }

    public Event(int id) {
        this();
        this.id = id;
    }

    public Event(int id, long duration) {
        this(id);
        this.duration = duration;
    }

    public Event(int id, String description) {
        this(id);
        this.description = description;
    }

    public Event(int id, long duration, String description) {
        this.id = id;
        this.duration = duration;
        this.description = description;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public long getDuration() {
        return duration;
    }

    public void setDuration(long duration) {
        this.duration = duration;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }
}