package org.jboss.qa.brms.drl.compile.example;

import java.lang.management.ManagementFactory;
import java.lang.management.MemoryPoolMXBean;

import org.junit.Test;
import org.kie.api.KieBase;
import org.kie.internal.utils.KieHelper;

public class CreateKBaseFrom10kRulesTest {
    private static int NANOS_PER_SEC = 1000 * 1000 * 1000;
    private static int LOOPS = 5;

    @Test
    public void testCreateKBasefromDT() throws Exception {
        printPermgenUsageOnStdout();
        for (int i = 1; i <= LOOPS; i++) {
            System.out.println("Running loop " + i);
            //createKBase("dtable1-kbase-creation.xls");
            createKBase("drl-kbase-creation-10k.drl");
            System.gc();
            printPermgenUsageOnStdout();
        }
        System.gc();
        System.out.println("End of the test, after manually calling GC...");
        printPermgenUsageOnStdout();
    }

    private KieBase createKBase(String resourceName) {
        long measureStart = System.nanoTime();
        KieHelper kieHelper = new KieHelper();
        kieHelper.addFromClassPath("/" + resourceName);
        KieBase kbase = kieHelper.build();
        long measureEnd = System.nanoTime();
        System.out.println("Just to be sure the code is not eliminated: packages=" + kbase.getKiePackages().size());
        System.out.println("KBase building took " + (measureEnd - measureStart) / NANOS_PER_SEC + "s.");
        return kbase;
    }

    private void printPermgenUsageOnStdout() {
        // this is JVM dependent, should work on Oracle JDK and OpenJDK
        for (MemoryPoolMXBean mx : ManagementFactory.getMemoryPoolMXBeans()) {
            if ("PS Perm Gen".equals(mx.getName())) {
                System.out.println(String.format("Permgen usage: %dMiB", mx.getUsage().getUsed() / 1024 / 1024));
            }
        }
    }

}
